//////////////////////////////////////////////////////////////////////
// VcCom
// www.vccom.net
// VcCom API VC++ 6.0 Example Code
// Version 1.00
// Date 01 Aug 2004
/////////////////////////////////////////////////////////////////////
// Description
//
// This file forms part of the VcCom API VC++ 6.0 Example Code
// in order to provide example usage of the VcCom API which is
// available from www.objectconsultans.co.uk
/////////////////////////////////////////////////////////////////////
// How To Use
//
// Please refer to the VcCom API VC++ 6.0 Example Code documentation
/////////////////////////////////////////////////////////////////////

// ClientTestDlgDlg.cpp : implementation file

#include "stdafx.h"
#include "ClientTestDlg.h"
#include "ClientTestDlgDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CClientTestDlgDlg dialog

CClientTestDlgDlg::CClientTestDlgDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CClientTestDlgDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CClientTestDlgDlg)
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CClientTestDlgDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CClientTestDlgDlg)
	DDX_Control(pDX, IDC_EDIT_MYID, m_EditMyId);
	DDX_Control(pDX, IDC_EDIT_MYNAME, m_editMyName);
	DDX_Control(pDX, IDC_EDIT_NAME, m_editName);
	DDX_Control(pDX, IDC_EDIT_MESSAGE, m_editMessage);
	DDX_Control(pDX, IDC_EDIT_ID, m_editId);
	DDX_Control(pDX, IDC_LIST, m_list);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CClientTestDlgDlg, CDialog)
	//{{AFX_MSG_MAP(CClientTestDlgDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BUTTON_ALL, OnButtonAll)
	ON_BN_CLICKED(IDC_BUTTON_NAME, OnButtonName)
	ON_BN_CLICKED(IDC_BUTTON_ID, OnButtonId)
	ON_BN_CLICKED(IDC_BUTTON_CLEAR, OnButtonClear)
	ON_WM_DESTROY()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CClientTestDlgDlg message handlers

BOOL CClientTestDlgDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	/////////////////////////////////////////////////////////////////////////////
	// ****** VcCom Specific Code ****** 
	// Connect to VcCom
    m_vc.Connect(this);
	// ****** VcCom Specific Code ****** 
	/////////////////////////////////////////////////////////////////////////////

    CString MyId = (m_vc.Id()).c_str();

	m_EditMyId.SetWindowText( MyId );
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CClientTestDlgDlg::OnDestroy() 
{
	CDialog::OnDestroy();
	
	/////////////////////////////////////////////////////////////////////////////
	// ****** VcCom Specific Code ****** 
	// Disconnect from VcCom
    m_vc.Disconnect();	
	// ****** VcCom Specific Code ****** 
	/////////////////////////////////////////////////////////////////////////////
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CClientTestDlgDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CClientTestDlgDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

// Standard OnOK
void CClientTestDlgDlg::OnOK() 
{
}

// Standard Cancel
void CClientTestDlgDlg::OnCancel() 
{
	CDialog::OnCancel();
}

// Clear our list of messages we have displayed in the listbox
void CClientTestDlgDlg::OnButtonClear() 
{
    m_list.ResetContent();
}

// This is how to send a ToAll message to VcCom
void CClientTestDlgDlg::OnButtonAll() 
{
	// Make sure we tel VcCom of our name (in case its changed in the edit box)
	CString myName;
    m_editMyName.GetWindowText(myName);
	m_vc.Name( (wchar_t*)_bstr_t(myName) );

    CString message;
    m_editMessage.GetWindowText(message);

    m_vc.SendToAll((wchar_t*)_bstr_t(message));
}

// This is how to send a ToName message to VcCom
void CClientTestDlgDlg::OnButtonName() 
{
	// Make sure we tel VcCom of our name (in case its changed in the edit box)
	CString myName;
    m_editMyName.GetWindowText(myName);
	m_vc.Name( (wchar_t*)_bstr_t(myName) );

    CString message;
    m_editMessage.GetWindowText(message);
    CString name;
    m_editName.GetWindowText(name);

    m_vc.SendToName((wchar_t*)_bstr_t(name), (wchar_t*)_bstr_t(message));
}

// This is how to send a ToId message to VcCom
void CClientTestDlgDlg::OnButtonId() 
{
	// Make sure we tel VcCom of our name (in case its changed in the edit box)
	CString myName;
    m_editMyName.GetWindowText(myName);
	m_vc.Name( (wchar_t*)_bstr_t(myName) );

    CString message;
    m_editMessage.GetWindowText(message);
    CString id;
    m_editId.GetWindowText(id);

    m_vc.SendToId((wchar_t*)_bstr_t(id), (wchar_t*)_bstr_t(message));
}

// SendToAll
// Called when another application sends a message to all
// other applications connected to the VcCom.
// Where
//	fromName = the name of the application that sent the message
//	fromId = the Id of the application that sent the message
//	message = the message
void CClientTestDlgDlg::SendToAll(
        const std::wstring & fromName,
        const std::wstring & fromId,
        const std::wstring & message)
{
    CString msg;
    msg += "SendToAll : from '";
    msg += fromName.c_str();
    msg += ":";
    msg += fromId.c_str();
    msg += "' : '";
    msg += message.c_str();
    msg += "'";
    m_list.AddString(msg);
}

// SendToName
// Called when another application sends a message to specified
// named applications connected to the VcCom.
// Where
//	fromName = the name of the application that sent the message
//	fromId = the Id of the application that sent the message
//	message = the message
void CClientTestDlgDlg::SendToName(
        const std::wstring & fromName,
        const std::wstring & fromId,
        const std::wstring & message)
{
    CString msg;
    msg += "SendToName : from '";
    msg += fromName.c_str();
    msg += ":";
    msg += fromId.c_str();
    msg += "' : '";
    msg += message.c_str();
    msg += "'";
    m_list.AddString(msg);
}

// SendToId
// Called when another application sends a message to specified
// application connected to the VcCom.
// Where
//	fromName = the name of the application that sent the message
//	fromId = the Id of the application that sent the message
//	message = the message
void CClientTestDlgDlg::SendToId(
        const std::wstring & fromName,
        const std::wstring & fromId,
        const std::wstring & message)
{
    CString msg;
    msg += "SendToId : from '";
    msg += fromName.c_str();
    msg += ":";
    msg += fromId.c_str();
    msg += "' : '";
    msg += message.c_str();
    msg += "'";
    m_list.AddString(msg);
}
