//////////////////////////////////////////////////////////////////////
// VcCom
// www.vccom.net
// VcCom API VC++ 6.0 Example Code
// Version 1.00
// Date 01 Aug 2004
/////////////////////////////////////////////////////////////////////
// Description
//
// This header file forms part of the VcCom API VC++ 6.0 Example Code
// in order to provide example usage of the VcCom API which is
// available from www.objectconsultans.co.uk
/////////////////////////////////////////////////////////////////////
// How To Use
//
// Please refer to the VcCom API VC++ 6.0 Example Code documentation
/////////////////////////////////////////////////////////////////////

// ClientTestDlgDlg.h : header file

#if !defined(AFX_CLIENTTESTDLGDLG_H__CE45D255_B074_48F3_AF4E_75D0B6CA027A__INCLUDED_)
#define AFX_CLIENTTESTDLGDLG_H__CE45D255_B074_48F3_AF4E_75D0B6CA027A__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

/////////////////////////////////////////////////////////////////////////////
// ****** VcCom Specific Code ****** 
// Include the VcComClientWrapper header file, has to be in your include path
//
// IF YOU ARE MISSING THIS FILE
// This is provided as part of the C++ example download in a directory 
// called VC Include
//
#include <VcComClientWrapper.h>
// ****** VcCom Specific Code ****** 
/////////////////////////////////////////////////////////////////////////////

/////////////////////////////////////////////////////////////////////////////
// CClientTestDlgDlg dialog

/////////////////////////////////////////////////////////////////////////////
// ****** VcCom Specific Code ****** 
// Inherit from the VcComClientWrapperCallback class so we get messages
// ****** VcCom Specific Code ****** 
/////////////////////////////////////////////////////////////////////////////
class CClientTestDlgDlg :
    public CDialog,
    public VcComClientWrapperCallback
{
// Construction
public:
	CClientTestDlgDlg(CWnd* pParent = NULL);	// standard constructor

// Dialog Data
	//{{AFX_DATA(CClientTestDlgDlg)
	enum { IDD = IDD_CLIENTTESTDLG_DIALOG };
	CEdit	m_EditMyId;
	CEdit	m_editMyName;
	CEdit	m_editName;
	CEdit	m_editMessage;
	CEdit	m_editId;
	CListBox	m_list;
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CClientTestDlgDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	HICON m_hIcon;

	// Generated message map functions
	//{{AFX_MSG(CClientTestDlgDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	virtual void OnOK();
	virtual void OnCancel();
	afx_msg void OnButtonAll();
	afx_msg void OnButtonName();
	afx_msg void OnButtonId();
	afx_msg void OnButtonClear();
	afx_msg void OnDestroy();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

protected:

	/////////////////////////////////////////////////////////////////////////////
	// ****** VcCom Specific Code ****** 
	// Impliment the pure virtual functions defined in the class we inhertied from
	// VcComClientWrapperCallback. These are called by VcCom when messages are
	// sent to this application.

	// SendToAll
	// Called when another application sends a message to all
	// other applications connected to the VcCom.
	// Where
	//	fromName = the name of the application that sent the message
	//	fromId = the Id of the application that sent the message
	//	message = the message
    void SendToAll(
            const std::wstring & fromName,
            const std::wstring & fromId,
            const std::wstring & message);

	// SendToName
	// Called when another application sends a message to specified
	// named applications connected to the VcCom.
	// Where
	//	fromName = the name of the application that sent the message
	//	fromId = the Id of the application that sent the message
	//	message = the message
    void SendToName(
            const std::wstring & fromName,
            const std::wstring & fromId,
            const std::wstring & message);

	// SendToId
	// Called when another application sends a message to specified
	// application connected to the VcCom.
	// Where
	//	fromName = the name of the application that sent the message
	//	fromId = the Id of the application that sent the message
	//	message = the message
    void SendToId(
            const std::wstring & fromName,
            const std::wstring & fromId,
            const std::wstring & message);
    private:

		// You need to hold a VcComClientWrapper in order for all this to work.
		// This allows VcCom to call the functions here as well as allowing
		// your application to call VcCom methods.
        VcComClientWrapper m_vc;
	// ****** VcCom Specific Code ****** 
	/////////////////////////////////////////////////////////////////////////////
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_CLIENTTESTDLGDLG_H__CE45D255_B074_48F3_AF4E_75D0B6CA027A__INCLUDED_)
